module Wrapybara
	class Attribute
		include Element
		
		def initialize(parent, attribute)
			@parent = parent
			@attribute = attribute
		end
		
		def value
			self
		end
		
		def should_exist
			raise UnmetExpectation, "Expected element #{self.parent_identifier} to have attribute '#{@attribute}'" if @parent.element[@attribute].nil?
		end
		
		def should_not_exist
			raise UnmetExpectation, "Did not expect element #{self.parent_identifier} to have attribute '#{@attribute}'" unless @parent.element[@attribute].nil?
		end
		
		def should_be(value)
			message = "Expected element #{self.parent_identifier} to have attribute '#{@attribute}' with value '#{value}'"
			raise UnmetExpectation, message unless @parent.element[@attribute] == value
		end
		
		def should_not_be(value)
			message = "Did not expect element #{self.parent_identifier} to have attribute '#{@attribute}' with value '#{value}'"
			raise UnmetExpectation, message if @parent.element[@attribute] == value
		end
	end
end