module Wrapybara
	class Button
		include Element
		
		def initialize(identifier, scope = default_scope, how = default_how)
			@identifier = identifier
			@how = how
			@scope = scope
			xpath = XPath::HTML.button(identifier)
			@element = get_element(xpath, scope)
		end
		
		def should_exist
			super "Expected a button #{self.element_identifier} to exist"
		end

		def should_not_exist
			super "Did not expect a button #{self.element_identifier}' to exist"
		end

		def click
			self.should_exist
			# Capybara method
			@element.click
		end
	end
end