module Wrapybara
	class Checkbox
		include Element
		
		def initialize(identifier, scope = default_scope, how = default_how)
			@identifier = identifier
			@how = how
			@scope = scope
			xpath = XPath::HTML.checkbox(identifier)
			@element = get_element(xpath, scope)
		end
		
		def should_exist
			super "Expected a checkbox #{self.element_identifier} to exist"
		end

		def should_not_exist
			super "Did not expect a checkbox #{self.element_identifier}' to exist"
		end

		def set(state)
			self.should_exist
			# Capybara method
			@element.set(state)
		end
		
		def check
			self.set(true)
		end
		
		def uncheck
			self.set(false)
		end
		
		def checked?
			self.should_exist
			# Capybara method
			@element.checked?
		end

		def should_be_checked
			raise UnmetExpectation, "Expected a checkbox #{self.element_identifier} to be checked" unless self.checked?
		end

		def should_not_be_checked
			raise UnmetExpectation, "Did not expect a checkbox #{self.element_identifier} to be checked" if self.checked?
		end
	end
end