module Wrapybara
	class Content
		include Element
		
		def initialize(identifier, scope = default_scope)
			@identifier = identifier
			@scope = scope
			#xpath = XPath::HTML.content(identifier)
			# the %{} string notation is used so double quotes can offset identifier, allowing identifier to contain single quotes/apostrophes.
			# also important to note is that this xpath requires text to be contained in something (div, p, span). any text just floating around
			# on the page will show up with a path of //html, which is not terribly useful later on.
			xpath = %{//*[contains(text(), "#{identifier}")]}
			@element = get_element(xpath, scope)
		end

		def click
			self.should_be_visible
			super
		end
		
		def should_exist
			super "Expected content #{self.element_identifier} to exist"
		end

		def should_not_exist
			super "Did not expect content #{self.element_identifier} to exist"
		end

		def element_identifier
			"'#{@identifier}'#{self.within(@scope)}"
		end
	end
end