module Wrapybara
	module FillableField
		def fill_in(value)
			self.should_exist
			# Capybara method
			@element.set(value)
		end

		def value
			self.should_exist
			(@element.value || '').strip
		end
		
		def empty?
			self.value == ''
		end

		def should_be_empty
			raise UnmetExpectation, "Expected text field #{self.element_identifier} to be empty" unless self.empty?
		end

		def should_not_be_empty
			raise UnmetExpectation, "Did not expect text field #{self.element_identifier} to be empty" if self.empty?
		end

		def has_content?(content)
			self.value =~ /#{content}/
		end

		def should_have_content(content)
			if content.blank?
				self.should_be_empty
			else
				raise UnmetExpectation, "Expected text field #{self.element_identifier} to have content '#{content}'" unless self.has_content?(content)
			end
		end

		def should_not_have_content(content)
			if content.blank?
				self.should_not_be_empty
			else
				raise UnmetExpectation, "Did not expect text field #{self.element_identifier} to have content '#{content}'" if self.has_content?(content)
			end
		end
	end
end