module Wrapybara
	class Image
		include Element
		
		attr_reader :element, :identifier, :how, :scope
		
		def initialize(identifier, scope = default_scope, how = default_how)
			@identifier = identifier
			@how = how
			@scope = scope
			xpath = "//img[@src='#{identifier}' or @id='#{identifier}' or @title='#{identifier}' or @alt='#{identifier}']"
			@element = get_element(xpath, scope)
		end
		
		def should_exist
			super "Expected an image #{self.element_identifier} to exist"
		end

		def should_not_exist
			super "Did not expect an image #{self.element_identifier}' to exist"
		end
	end
end