module Wrapybara
	class Link
		include Element
		
		attr_reader :element, :identifier, :how, :scope

		def initialize(identifier, scope = default_scope, how = default_how)
			@identifier = identifier
			@how = how
			@scope = scope
			xpath = "//a[@href='#{identifier}' or @id='#{identifier}' or @title='#{identifier}' or contains(normalize-space(), '#{identifier}')]"
			@element = get_element(xpath, scope)
		end
		
		def should_exist
			super "Expected a link #{self.element_identifier} to exist"
		end

		def should_not_exist
			super "Did not expect a link #{self.element_identifier}' to exist"
		end

		def click
			self.should_exist
			# Capybara method
			@element.click
		end
	end
end