module Wrapybara
	class TableBody
		include Element

		attr_reader :parent, :element

		def initialize(table)
			@parent = table
			@element = table.element.find('tbody') rescue nil
		end
		
		def should_exist
		 	super "Expected table #{@parent.how} '#{self.parent_identifier} to have a body"
		end

		def should_not_exist
			super "Did not expect table #{@parent.how} '#{self.parent_identifier} to have a body"
		end

		def cell(*args)
			TableCell.new(self, args)
		end
		
		def should_have_cells(labels)
			labels.each do |label|
				self.cell(label).should_exist
			end
		end

		def should_not_have_cells(labels)
			labels.each do |label|
				self.cell(label).should_not_exist
			end
		end
		
		def exists?
			!@element.nil?
		end
	end
end