module Wrapybara
	class TableHead
		include Element

		attr_reader :parent, :element
		
		def initialize(table)
			@parent = table
			@element = table.element.find('thead') rescue nil
		end
		
		def should_exist
			super "Expected table #{self.parent_identifier} to have a head"
		end

		def should_not_exist
			super "Did not expect table #{self.parent_identifier} to have a head"
		end

		def cell(*args)
			TableCell.new(self, args)
		end
		
		def has_column?(label)
			self.cell(label).exists?
		end

		def should_have_cells(labels)
			labels.each do |label|
				self.cell(label).should_exist
			end
		end

		def should_not_have_cells(labels)
			labels.each do |label|
				self.cell(label).should_not_exist
			end
		end
	end
end