# This module is, admittedly, something of a hack. In order to reliably (across browsers and testing libraries) test for
# an element having focus, I resorted to adding some JavaScript event handling to read/write an attribute on focus/blur.
# Not pretty, but HtmlUnit, which Akephalos uses, did not recognize document.activeElement, so I had to roll my own
# solution. To make it easier for you to use this module, the corresponding JavaScript is included in focus_tracking.js.
# See it for usage notes.

# To use Wrapybara's focus handling capabilities, require wrapybara/ext/focus_handling in some file that gets loaded (I use
# support/extras.rb so I don't pollute env.rb) and then optionally set Wrapybara.focus_attribute to whatever the element
# attribute will be. As you can see below, Wrapybara checks the value of the attribute against what you say it should be
# when the element has focus.

module Wrapybara
	def self.focus_attribute=(attribute)
		@focus_attribute = attribute
	end
	
	def self.focus_attribute
		@focus_attribute || 'has-focus'
	end
	
	def self.focus_value=(value)
		@focus_value = value
	end
	
	def self.focus_value
		@focus_value || 'true'
	end
	
	module Element
		def focused?
			self.should_exist
			element[Wrapybara.focus_attribute] == Wrapybara.focus_value
		end
		
		def should_be_focused
			message = "Expected element #{self.element_identifier} to be focused"
			raise UnmetExpectation, message unless self.focused?
		end
		
		def should_not_be_focused
			message = "Did not expect element #{self.element_identifier} to be focused"
			raise UnmetExpectation, message if self.focused?
		end
	end
end