# add this directory to the load path if it's not already included
this_dir = File.expand_path(File.dirname(__FILE__))
$: << this_dir unless $:.include?(this_dir)

module Wrapybara
	class UnmetExpectation < Exception; end

	def host
		Capybara.app_host
	end

	def current_path
		Capybara.current_path
	end
	
	def current_url
		Capybara.current_url
	end
	
	def current_path_is?(path)
		path = path.gsub('/', '\/').gsub('?', '\?')
		(current_url || current_path) =~ /#{path}/
	end

	def current_path_should_be(path)
		raise UnmetExpectation, "Expected the current path to be '#{path}'" unless current_path_is?(path)
	end

	def current_path_should_not_be(path)
		raise UnmetExpectation, "Did not expect the current path to be '#{path}'" if current_path_is?(path)
	end
end

require 'xpath'
require 'element'
require 'elements/attribute'
require 'elements/button'
require 'elements/checkbox'
require 'elements/content'
require 'elements/form'
require 'elements/image'
require 'elements/label'
require 'elements/link'
require 'elements/file_field'
require 'elements/fillable_field'
require 'elements/option'
require 'elements/password_field'
require 'elements/radio_button'
require 'elements/select'
require 'elements/table'
require 'elements/table_body'
require 'elements/table_cell'
require 'elements/table_head'
require 'elements/text_area'
require 'elements/text_field'

World(Wrapybara)
